two new heuristics for the location set covering problem

14
Top (1994) Vol. 2, No. 2, 315-328 315 Two New Heuristics for the Location Set Covering Problem M. Almifiana and J.T. Pastor Dept. of Stat. and Oper. Res., University of Alicante, Spain SUMMARY In this paper we present two new greedy-type heuristics for solving the location set covering problem. We compare our new pair of algorithms with the pair GH1 and GH2 [Vasko and Wilson (1986)] and show that they perform better for a selected set of test prob- lems. Keywords: Location set covering problem, heuristics 1. INTRODUCTION The set covering problem (SC) was one of the first problems to be shown to be NP complete [Karp (1972)]. Its formulation as an integer program, due to [Roth (1969)], is Min cT x s.t. Ax>e x e {0,1} n , where A is the so called "cover matrix", with m rows and n columns, whose elements aij are either 0 or 1, e is the vector of l's, c is the Received: August 1993 Revised: October 1994

Upload: m-alminana

Post on 19-Aug-2016

214 views

Category:

Documents


1 download

TRANSCRIPT

Page 1: Two new heuristics for the location set covering problem

Top (1994) Vol. 2, No. 2, 315-328 315

Two New Heuristics for the Location Set Covering Problem

M. Almifiana and J.T. Pastor Dept. of Stat. and Oper. Res., University of Alicante, Spain

SUMMARY

In this paper we present two new greedy-type heuristics for solving the location set covering problem. We compare our new pair of algorithms with the pair GH1 and GH2 [Vasko and Wilson (1986)] and show that they perform better for a selected set of test prob- lems.

K e y w o r d s : Location set covering problem, heuristics

1. I N T R O D U C T I O N

The set covering problem (SC) was one of the first problems to be shown to be NP complete [Karp (1972)]. Its formulation as an integer program, due to [Roth (1969)], is

Min cT x

s.t.

A x > e x e {0,1} n ,

where A is the so called "cover matr ix", with m rows and n columns, whose elements aij are either 0 or 1, e is the vector of l 's , c is the

Received: Augus t 1993 Revised: October 1994

Page 2: Two new heuristics for the location set covering problem

316 M. A lmi~ana and J . T . Pas tor

cost vector -with 0 or positive integer elements- and xj = 1 if column j belongs to the solution or, otherwise, x j - - O.

The aim of the SC problem is to cover all rows of A with a subset of columns at minimum cost. Column j is said to cover row i if, and only if, aij = 1.

There are many known applications of the SC problem. For exam- ple [Salverson (1955)] has solved an assembly line balancing problem; [Walker (1974)] has assigned ladder trucks to fire stations and [Marsten et al. (1979)] have solved crew scheduling problems for airline compa- nies. [ReVelle et hi. (19.77)] reported more than one hundred of applica- tions in the location of emergency services by means of a particular SC problem, the so called LSCP (location set covering problem).

The LSCP, due to [Toregas et al. (1971)], is a very well known problem in location theory and is considered as the startpoint of two big families of location covering problems: the problems which provide additional coverage and the problems which consider probabilistic re- strictions. (For a complete classification scheme, see [ReVelle (1989)]). We get a LSCP simply by setting all the cost coefficients, cj equal to 1 (or, the equivalent, equal to any positive constant). For this reason it is also known as the set covering problem with unicosts. This problem is surprisingly more difficult to solve than the original SC. Large problems are usually solved by a greedy type heuristic ([Balas and Ho (1980)], [Vasko and Wilson (1984 and 1986)]). Heuristics are particularly inter- esting in production processes where a solution needs to be obtained within a reasonable period of time (see [Vasko et al. (1989)].

In this paper we are going to design two new heuristics for the LSCP closely related to the heuristics GH1 and GH2 presented in [Vasko and Wilson (1986)]. Although [no (1982)] has sown that aH the greedy type heuristics have the same worst case bound, experimental differences can usually be detected. We have found that our pair of heuristics work, on average, better than the pair of Vasko and Wilson.

2. T H E T W O N E W H E U R I S T I C S

The formulation of the LSCP as an integer programming problem is

Min eT x

s . t .

A x > e

x e {0, 1) '~ .

Page 3: Two new heuristics for the location set covering problem

Two New Heuris t ics .for the Location Set Covering Problem 3 1 7

The two heuristics, GH1 and GH2, defined by Vasko and Wilson for solving the LSCP are based on the heuristic of [Balas and Ho (1980)], designed to solve the SC problem. Our new heuristics consti tute a re- finement of the two presented by Vasko and Wilson. For the sake of clarity we adopt, from here on, the location nomenclature. Hence each row of the cover matr ix will be assimilated to a demand node and each column to a service point.

D e f i n i t i o n . A demand node is called a simple node if it is covered by a unique service point.

It is obvious that the service points which cover simple nodes must belong to any optimal solution. Therefore, the original matr ix A can be reduced by eliminating the columns which cover simple nodes and all the rows which are covered by these columns. Although there are some other reduction rules (see, v.gr., [Garfinkel and Nemhauser (1972)]) and also the possibility of reiterating them, we have deleted them in this final version in order to get reasonable fast heuristics.

In the two algorithms we are going to present, the solution is con- structed step by step, by adding one service point at each iteration. If N = {1, 2 , . . . , n} is the set of indexes associated with the service points, the partial solution of each step will be identified by the set S, a subset of N. Furthermore, M will denote the set of indexes associated with those demand nodes which are still uncovered and will be reduced at each i teration until M = 0. Finally ITI will denote the number of elements of the finite set T.

The steps of our first heuristic, called FMC, are:

Step 1. Set S = 0, and M = { 1 , 2 , . . . , m } .

Step 2. Search the simple nodes and update S and M. If M = 0, stop: S gives the optimal solution. Otherwise set t = 1.

Step 3. (Iteration t begins) For each demand node i, i E M, evaluate di = [{j E N - S / a i j = 1}[. Define M* = {i* E M/di. < di, Vi E M}, that is, M* includes all

rows with an equal minimum di. Define g ( t ) = {j e N - S/aij = 1 for some i e M*}, i.e. the subset

of columns each of which covers at least one row belonging to M*.

Page 4: Two new heuristics for the location set covering problem

318 M. Atmi~iana and J . T . P a s t o r

Step 4. For each j E N(t) evaluate pj, the number of rows it covers, pj = [{i E M/aij = 1}l , and define P* = {j* E N(t)/pj. > pj, Vj N(t)}, i.e. the subset of columns of N(t) with maximum coverage.

Step 5. If IP*I = 1, set j(t) = j* E P* and go to step 7; otherwise, continue.

Step 6. Take as j(t) the element j* of P* which maximizes ~ieMdiaij*. In case of ties choose as j(t) the lowest index of them.

Step 7. Set S = S U { j ( t ) } , M = M - ( i E M/a~j(~) = 1}. If M = 0, go to step 8. Otherwise, set t = t + 1 and return to step 3 (end of iteration t).

Step 8. Check for redundant service points in the final solution set: for a j E S, take S* = S - {j}. If S* is a feasible solution for the LSCP, eliminate j by setting S = S*. In any case repeat the process until all the j's have been checked.

Observe that step 8 will ehminate all the redundant j's.

Comparing FMC with GH1 we want to point out that the differences axe not only the inclusion of Steps 2 and 6 but the consideration in Step 3 of all the rows with a minimum di. This differs from algorithm GH1 which considers only one of those rows, without specifying which one.

Our secong heuristic, called CMA, is an evolution of heuristic GH2 the same way as what we have shown for FMC with regard to GH1. More precisely, the only difference with heuristic FMC lies in the definition of N(t). Now the definition is straightforward: N(t) = N - S and, therefore, we only have to simplify Step 3 of the above algorithm.

3. C O M P U T A T I O N A L R E S U L T S

We have programmed the two new algorithms, FMC and CMA, as well as the two old ones, GH1 and GH2, in FORTRAN, using the Microsoft Compiler V4. They have been run on a PC IBM PS/2-55 with 2Mg of KAM and math-coprocessor.

We have randomly generated three blocks of problems, called A, B and C. Each has 20 problems but different dimensions: 50x 100, 75x 200 and 100• In each block there are four groups of problems corre- sponding to the different densities of 5%, 10%, 15% and 20% (the density of the cover matrix is defined as the percentage of l's therein). We have also considered a fourth block of problems, called D, which includes 5

Page 5: Two new heuristics for the location set covering problem

T w o N e w H e u r i s t i c s .for the Loca t ion Se t C over i ng Prob l em 3 1 9

problems with dimensions 50 x 500 and 2070 of density. Block D is due to [Beasley (1990a)] and can be obtained by e-mail (see [Beasley (1990b)]). Before evaluating the optimal and the different heuristic solutions for any generated problem, we classified it as trivial or non-trivial. A trivial problem is one which has a row of zeros, being, therefore, infeasible or, alternatively, there exists a column of l 's, which constitutes by itself an optimal solution for the problem.

In order to know the optimal integer value of the generated prob- lems we initially resorted to the linear and integer software package "Industrial LINDO". We did not succeed in finding the integer solu- tion of the block of problems of size 100 x 400 on the PC, due to the great amount of time needed for solving most of these problems. With one of them, the PC was running over two months without reaching its solution. Therefore we turned to a mainframe and solved this block of problems using the programming lenguage CPLEX. One problem has consumed more than eleven CPU hours for searching over 50000 branch and bound nodes and doing more than 3.5 millions of iterations.

The results obtained are gathered in tables 1 to 4 in which the first column contains the relaxed linear value; the second contains the optimal integer value and the third one shows the gap between the first two columns. From the 4th to the l l t h column we present the optimal values obtained for each of the four heuristics under study, as well as their resolution times (in seconds). Each of the last two columns show the best values, one obtained with the old set of heuristics (GH1 and GH2) and the other one with the new set (FMC-CMA).

Some comments are in order: if we compare FMC with CMA we conclude that CMA is clearly better except for the problems of block A, where FMC and CMA appear on an equal footing. The major differ- ence corresponds to block D. This could mean that CMA works better than FMC when the dimensions of the problems are higher. The same comparison is valid for the old GH1 and GH2. In fact, if we resume the number of best solutions acquired by each heuristic (with regard to all heuristics) in our sample, we obtain

Nr. of best solutions Percentage (over 65 problems) GH1 30 46.2% GH2 4O 61.5% FMC 44 66.2% CMA 5O 76.970

Page 6: Two new heuristics for the location set covering problem

320 M. Alrn iKana and J . T . P a s t o r

A1

A2

A3

A4

A5

I i 14.57 16 1.43

16.0 16 0.0

15.22 16 0.78

16.66 17 0.34

15.18 16 0.72

Number of best solutions found /

AA6..~ 7.67 9 1.33

A7 7.77 9 1.23

A8 8.11 10 1.89

A9 8.82 10 1.18

8.20 10 1.80

Number of best solutions found

5.23 7 1.77

5.87 7 1.13

5.63 7 1.37

_ ~ 5.62 7 1.38

A15 I 5.71 7 1.29

Number of best solutions found

. • 4.29 6 1.71

_ ~ 4.39 6 1.61

. ~ 4.20 6 1.8

A ~ 4.25 6 1.75

A20 I 4.23 6 1.77

TABLE 1 - PROBLEMS OF DIMENSION 50 X 100

i

. [,I val-time I val-time [ val-time I val-time

17 2 17 2 17 3 18 2

17 2 18 2 17 3 19 2

18 3 18 3 17 3 17 2

20 3 18 3 19 3 18 2

17 2 18 2 17 3 17 2

3 2 4 3

10 2 9 2 10 2 9 2

9 2 10 2 9 2 10 2

11 2 10 2 10 2 11 2

11 2 11 2 11 2 11 2

12 2 11 2 11 3 11 2

2 4 4 3

7 2 7 2 7 2 7

8 2 9 2 8 2 7

8 2 9 2 8 2 8

8 2 7 2 7 3 7

$ 2 8 2 7 2 8

2 2 4 4

6 2 6 2 6 2 6

8 2 6 2 7 2 6

7 2 7 2 7 2 6

6 2 6 2 6 2 6

7 2 7 2 6 2 7

GH1- FMC- GH2 CMA

17 17

17 17

18 17

18 18

17 17

l 4 5 i

9 9

9 9

10 10

11 11

11 11

5 5

2 7 7

2 8 7

2 8 8

2 7 7

2 8 7

3 5

2 6 6

2 6 6

2 7 6

2 6 6

2 7 6

3 5

15 20

Number of best solutions found 2 3 3 4

Total number of best solutions found

9 11 15 14

Page 7: Two new heuristics for the location set covering problem

Two New Heuristics for the Location Set Covering Problem 321

B1

B2

B3

B4

B5

I OPTL I OPT GAP

I

14.31 16

14.24 16

14.31 16 1.69

13.69 14

15.66 18

TABLE 2 - PROBLEMS OF DIMENSION 75 X 200

i i I val-time val-time val-time val-time

1.69 17 6 17 6 17 6 16 5

1.76 18 6 19 5 19 6 19 6

17 6 18 5 18 7 19 6

1.31 17 6 17 5 19 6 15 5

1.34 21 6 20 5 20 6 20 6

Number of best solutions found

B6 7.96 10 2.04

B7 8.07 10 :1.93

B8 7.76 10 1.24

B9 7.72 10 1.28

B10 7.79 10 1.21

Number of best solutions found

B l l 5.58 8 2.42

B12 5.59 8 2.41

B13 5.35 8 2.65

B14 5.06 7 1.94

B15 5.49 8 2.51

Number of best solutions found

B16 4.22 6 1.78

B17 4.32 7 2.68

B18 4.16 6 1.84

B19 4.01 6 1.99

B20 4.17 6 1.83

Number of best solutions found

Total number of best solutions found

GHI- I FMC- GH2 CMA

17 16

18 19

17 18

17 15

20 20

2 1 1 3 3 3

13 5 11 6 13 6 11 6

12 6 12 6 12 6 11 6

11 5 12 6 11 6 12 6

11 6 10 5 10 7 11 6

11 5 12 6 11 6 11 6

11 11

12 11

11 11

10 10

11 11

2 2 3 3 4 4

9 6 9 4 9 5 8 6

10 5 9 6 9 7 9 6

9 6 8 5 8 6 8 6

9 5 8 6 8 6 8 5

9 6 8 5 9 6 8 6

0 4 3 5

7 6 7 6 7 6 7 6

7 6 7 5 7 6 7 6

7 5 7 6 7 7 7 6

6 5 6 5 6 7 6 6

7 5 7 6 7 7 7 6

9 8

9 9

8 8

8 8

8 8

4 5

7 7

7 7

7 7

6 6

7 7

5 5 5 5 5 5 II

n

9 12 12 16 16 17

Page 8: Two new heuristics for the location set covering problem

322 M. A l m i f i a n a and J , T . P a s t o r

C1

C2

C3

C4

C5

OPTL I OPT I GAP

13.03 16

13.04 16

13,87 17

13.56 16

12,79 16

TABLE 3 - PROBLEMS OF DIMENSION 100X400

I GH1 GH2 FMC CMA val-time val-time val-time val-time

2.97 19 15 18 15 18 15 18 15

2.96 18 15 18 15 18 15 18 15

3.13 21 15 20 15 18 15 20 15

2.44 19 14 18 15 18 16 17 15

3.21 19 14 18 14 18 16 17 15

Number of best solutions found

C6 7.61 11 3.39

C7 7.15 10 2.85

C8 7.39 10 2.61

C9 7.37 10 2.63

C10 7.48 11 3.52

Number of best solutions found

2.83

2.81

2.88

2.75

2.70

C l l 5.17 8

C12 5.19 8

C13 5.12 8

C14 5.25 8

C15 5.30 8

Number of best solutions found

C16 3.99 7 3.01

C17 4.04 7 2.96

C18 4.07 7 2.93

C19 4.24 7 2.76

C20 4.00 6 2.00

1 2 3 4

12 14 12 14 12 16 12 16

12 15 12 14 12 16 11 15

12 14 11 14 10 16 11 15

11 14 10 14 10 15 11 15

13 14 12 14 12 16 I1 15

1 2 3 3

10 15 9 14 9 16 9 15

8 15 8 14 9 16 8 15

9 15 9 15 9 16 9 16

9 14 9 14 8 17 9 16

8 14 9 14 8 16 9 16

3 3 4 3

8 15 7 14 8 17 7 16

7 14 7 14 7 16 7 16

7 15 7 14 7 16 7 16

8 15 7 14 7 16 7 15

7 14 7 14 7 16 7 16

GH1- FMC-

I 18 18

18 18

20 18

18 17

18 17

12

12

11

10

12

12

i i

10

10

11

Number of best solutions found 3 5 4 5 5 5

Total number of best solutions 8 12 14 15 14 20 found

Page 9: Two new heuristics for the location set covering problem

Two New Heuristics for the Location Set Covering Problem ~ 2 3

D1

D2

D3

D4

D5

TABLE 4 - PROBLEMS OF DIMENSION 50 X 500

OPTL [ OPT t GAP

3.48 5 1.52

3.38 5 1.62

3.29 5 1.71

3.45 5 1.55

3.39 5 1.61

OUl i i i CMA val-time val-time val-time val-time

6 9 5 9 6 11 5 10

5 9 5 9 6 11 5 10

5 9 5 10 5 11 5 10

6 9 6 9 6 10 6 10

5 9 5 10 5 I1 5 10

GH1- FMC- GH2 CMA

5 5

5 5

5 5

6 6

5 5

Number of best solutions found 4 5 2 5 5 5

Therefore our pair of heuristics are individually better than any of the old ones. Moreover they are also pairwise even better: the pair FMC-CMA reaches the best solution in 62 problems out of 65. That is 95.4% of the cases. Meanwhile the pair GH1-GH2 gets only the best solution in 50 problems. That represents 76.9% of the cases.

In relation to the computational times, we have to point out that they are slightly shorter for the old heuristics than for the new ones. This fact is not surprising at all, considering that each of the new heuristics includes not only the steps of the corresponding old one but two more. Each computational time corresponds exclusively to the execution time of each algorithm and does not include either the initial period devoted to reading the data or the last period of print-out of the results.

Let us examine in more detail the behaviour of the heuristics focus- ing on the dimensions of the problems solved. The results are presented in Table 5 and in Figure 1.

Again we observe that CMA algorithm is the best one except for the problems of dimensions 50 • 100, where the FMC algorithm shows a slightly better behaviour (75% of best solutions versus 70%). Undoubtly, algorithm GH1 is the worst one. The four algorithms are graphically compared in Figure 1. The last two columns of Table 5 show clearly the improvement obtained by considering our pair of new heuristics instead of the old pair. Our pair always achieve the best solution in three con- sidered dimensions and in the fourth one they perform better than the old pair.

Page 10: Two new heuristics for the location set covering problem

324 M. AlmiKana and J . T . P a s t o r

Table $ . Percentage of best solutions based on the dimension of the problems

Dimension Num Probl GH1 GH2 FMC CMA GH1-GH2 FMC-CMA

50XlO0

75X200

lOOX400

50X500

20 45 55 75

20 45 60 60

20 40 60 70

5 80 100 40

100

80 85

70 75

80

75 70

100 lOO

lOO

16o

120

50X100 75X200 100X400 50X500

I"~'GH1 "="GH2 "=-FMC "~-CMA I

Figure 1.

Let us now group the results according to the densities of the prob- lems. The corresponding percentages of best solutions are contained in Table 6, whereas Figure 2 presents a graphical display of the behaviour of the four heuristics.

The first place is again achieved by algorithm CMA except for the group of problems with a density of 10%, where algorithm FMC performs slightly better. Only one of the old algorithms in only one group of problems performs better than one of the two new algorithms. The reason is that algorithm FMC has obtained mediocre results for the problems of the original group D.

Page 11: Two new heuristics for the location set covering problem

Two New Heuris t ics for the Location Set Covering Problem 3 2 5

Table 6 - Percentage of best solutions based on the density of the problem

Num Probl GH1 GH2 FMC CMA GH1-GH2 FMC-CMA Density

5 % 15 40.0 33.3 53.3

10 % 15 33.3 53.3 66.6

15 % 15 33.3 60.0 73.3

20 % 20 70.0 90.0 70

66.6 66.6 86.6

60.0 73.3 93.3

80.0 73.3 100

95.0 90.0 100

100

8O

60

40

20 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

5% 10% 15% 20%

-"-GH1 -*'GH2 "~FMC "*-CMA]

Figure 2.

Finally, an important measure for establishing the accuracy of an heuristic is given by the following expression

l o o / ( z . o u - zo ,)/zo t .

This percentage deviation gives us an idea about how close the heuristic solution is with regard to the optimal solution. An algorithm with small average deviation may be preferred to another one with higher average deviation even if the latter one achieves a higher percentage of best solutions than the first one. Table 7 shows the average deviations of the four heuristics for the different groups of problems.

Page 12: Two new heuristics for the location set covering problem

3 26 M. A l m i ~ a n a and J . T . P a s t o r

The inspection of Table 7 is left to the reader; conclusions are very much like those obtained before.

Table 7 - Percentage average deviations

Problems GH1 GH2

A1 - A5

A6 - A10

AI 1 - A15

A16 - A20

Group A aver.

B1 - B5

B6 - B10

B l l - B15

9.78 9,93

10.22 6.22

11.44 14.28

13.33 6.66

BI6 - B20

Group B aver. 14.21 11,47

C1 - C5

C6 - C10

CI1 - C 1 5

11.19 9.27

12.62 14.01

16.00 14.00

18.21 7.86

9,99 9.99

18.46 13.53

15.40 9.64

10.00 10.00

9.05 3.33 C16 - C20

Group C aver. 13.24 9.13

D1-D5 8.00 4.00

General average

I FMC [ CMA

7.35 9.41

6.22 822

5.72 5.72

6.66 3,33

16.49 16.80

16.86 11.15

14.00 12.00

10.36 5.36

9.99 9.99

112.80 19.63

11.18 11.03

7.64 7.82

7.50 10.00

6.19 3.33

8.13 8.05

12.00 4.00

12.31 9 . 5 0 1 9 . 3 6 1 7 . 8 4

GH1 -GH2 FMC-C~A

7A3 6.18

4.00 4.00

8.58 2.86

6.66 0.00

6.67 3.26

11.51 9.90

10.00 8.00

7.86 5.36

9.99 9.99

9.84 8,31

8.50 5.21

4.00 4.00

8.00 [ 5.41

13.53 8.68

9.64 3.82

7.50 5.00

3.33 3.33

Page 13: Two new heuristics for the location set covering problem

Two New Heuristics for the Location Set Covering Problem 327

4. C O N C L U S I O N S

As a summary, we have experimentally stated that our new Mgorithm CMA shows a higher performance then the other three heuristics consid- ered, with regard to the number of best solutions found as well as with regard to the average accuracy of the solutions. The second position also corresponds to one of our heuristics, the so called FMC. For problems with low dimensions or low density, algorithm FMC may perform better than algorithm CMA. In any case our new pair of heuristics offer better solutions than the old pair GH1-GH2.

The above results are relevant both for solving large location set covering problems, which arise in production processes, and for the lo- cution of emergency services. In the future more work has to be done. A sensible conjecture is that the hybrid heuristics designed by [Vasko and Wilson (1986)] will work better if they consider the pair FMC-CMA instead of the pair GH1-GH2.

A C K N O W L E D G E M E N T S

The authors are deeply grateful to two anonymous referees for their advice and suggestions.

R E F E R E N C E S

Baker, E. (1981). Heuristics algorithms for the weighted set covering problem. Computers and Operations Research 8(4), 303-310.

Balas, E. and A. H0 (1980). Set covering algorithms using cutting planes, heuristics, and subgradient optimization: A computational study. Mathematical Programming 12, 37-60.

Beasley, J.E. (1990a). A lagrangian heuristic for set covering problem. Naval Research Logistics Quaterly 37, 151-164.

Beasley, J.E. (1990b). OR-Library: Distributing test problems by electronic mail. Journal of the Operational Research Society 41, 1069-1072.

Garfinkel, R.S. and G.L. Nemhauser (1972). Integer programming, Wiley, New York.

Ho, A.C. (1982). Worst case analysis of a class of set covering heuristics. Mathematical Programming 23(2), 170-180.

Karp, R.M. (1972). Reducibility among combinatorial problems, in Complexity of computer computations (R.E. Miller and J.W. Thatcher, Eds.), Plenium Press, New York, 85-104.

Page 14: Two new heuristics for the location set covering problem

328 M. A lmi~ana and J . T . Pas to r

Marsten, R.E., M.R. Muller and Killion (1979). Crew planning at Flying Tiger: a successful application of integer programming. Management Science 20, 779-787.

Marsten, R.E. and F. Shepardson (1981). Exact solutions of crew schedulling problems using the set partitioning problem: Recent successful applications. Networks 11,165-177.

Revelle, C. (1989). Review, Extension and Prediction in Emergency Service Siting Models. European Journal of Operations Research, 40, 58-69.

Revelle, C., D. Bigman, J. Cohon and R. Church (1977). Facility Location: A Review of Context-Free and EMS Models. Health Services Research, 12, 129-146.

Roth, R. (1969). Computer solutions to minimum-cover problems. Operations Research 17, 455-465.

Salverson, M.E. (1955). The assambly line balancing problem. Journal of Industrial Engineering 6, 18-25.

Toregas, C., R. Swain, C. Revelle and L. Bergman (1971). The location of emergency services facilities. Operations Research 19, 1363-1373.

Vasko, F.J. and G.R. Wilson (1984). An efficient heuristic for large set covering problems. Naval Research Logistics Quaterly 31,163-171.

Vasko, F.J. and G.R. Wilson (]986). Hybrid Heuristics for Minimum Cardinality set covering problems. Naval Research Logistics Quaterly 33, 241-249.

Vasko, F.J., F.E. Wolf, K.L. Stott and J.W. Scheirer (1989). Selecting Optimal Ingot Sizes for Bethlehem Steel. Interfaces, 19/1, 68-84.

Walker, W. (1974). Application of the set covering problem to the assignment of ladder trucks to .fire house. Operations Research 22, 275-277.